﻿using System;
// Класс с индексатором:
class MyClass{
   // Целочисленное поле:
   public int code;
   // Конструктор с одним аргументом:
   public MyClass(int n){
      code=n;
   }
   // Целочисленный индексатор с индексом, который является
   // объектом класса MyClass:
   public int this[MyClass obj]{
      // Метод вызывается при считывании значения
      // выражению с проиндексированным объектом:
      get{
         // Результат:
         return code-obj.code;
      }
      // Метод вызывается при присваивании значения
      // выражению с проиндексированным объектом:
      set{
         // Присваивается значение полю:
         code=obj.code+value;
      }
   }
}
// Класс с главным методом:
class NonIntIndexDemo{
   // Главный метод:
   static void Main(){
      // Создание объекта:
      MyClass A=new MyClass(100);
      // Проверка значения поля объекта:
      Console.WriteLine("Объект A: {0}",A.code);
      // Создание объекта:
      MyClass B=new MyClass(150);
      // Проверка значения поля объекта:
      Console.WriteLine("Объект B: {0}",B.code);
      // Использование индексатора:
      int num=A[B];
      Console.WriteLine("Выражение A[B]={0}",num);
      Console.WriteLine("Выражение B[A]={0}",B[A]);
      A[B]=200;
      // Проверка значения поля объекта:
      Console.WriteLine("Объект A: {0}",A.code);
   }
}