﻿using System;
// Класс с двумерным индексатором:
class MyClass{
   // Закрытое поле, являющееся ссылкой на
   // целочисленный массив:
   private int[] vals;
   // Закрытое поле, являющееся ссылкой на
   // символьный массив:
   private char[] ckey;
   // Закрытое поле, являющееся ссылкой на
   // текстовый массив:
   private string[] skey;
   // Закрытый метод для добавления новых элементов
   // в массивы:
   private void add(char a,string b,int n){
      // Локальная переменная для записи размера
      // новых массивов:
      int size;
      // Переменная для символьного массива:
      char[] s;
      // Переменная для текстового массива:
      string[] t;
      // Переменная для целочисленного массива:
      int[] v;
      // Определение размера новых массивов:
      if(vals==null) size=1;    // Если массива нет
      else size=vals.Length+1;  // Если массив существует
      // Создание символьного массива:
      s=new char[size];
      // Значение последнего элемента созданного массива:
      s[s.Length-1]=a;
      // Создание текстового массива:
      t=new string[size];
      // Значение последнего элемента созданного массива:
      t[t.Length-1]=b;
      // Создание целочисленного массива:
      v=new int[size];
      // Значение последнего элемента созданного массива:
      v[v.Length-1]=n;
      // Заполнение созданных массивов:
      for(int k=0;k<size-1;k++){
         s[k]=ckey[k];
         t[k]=skey[k];
         v[k]=vals[k];
      }
      // Новые значения полей:
      ckey=s;
      skey=t;
      vals=v;
   }
   // Переопределение метода ToString():
   public override string ToString(){
      // Текстовая переменная:
      string txt="Содержимое объекта:\n";
      // Если массив существует:
      if(vals!=null){
         // Перебор элементов массивов:
         for(int k=0;k<ckey.Length;k++){
            // Добавление текста к текущему значению:
            txt+=ckey[k]+" : "+skey[k]+" : "+vals[k]+"\n";
         }
      }else{ // Если массива нет
            // Добавление текста к текущему значению:
         txt+="Пустой объект\n";
      }
      // Результат метода:
      return txt;
   }
   // Целочисленный индексатор с двумя индексами
   // символьного и текстового типа:
   public int this[char a,string b]{
      // Метод вызывается при считывании значения
      // выражения с проиндексированным объектом:
      get{
         // Если массив существует:
         if(vals!=null){
            // Перебор элементов массива:
            for(int k=0;k<ckey.Length;k++){
               // Если элемент найден:
               if(a==ckey[k]&&b==skey[k]){
                  // Значение выражения:
                  return vals[k];
               }
            }
         }
         // Код выполняется, если массив не существует или
         // если элемент не найден:
         int res=0;    // Значение для нового элемента
         add(a,b,res); // Добавление нового элемента
         return res;   // Значение выражения
      }
      // Метод вызывается при присваивании значения
      // выражению с проиндексированным объектом:
      set{
         // Если массив существует:
         if(vals!=null){
            // Перебираются элементы массива:
            for(int k=0;k<ckey.Length;k++){
               // Если элемент найден:
               if(a==ckey[k]&&b==skey[k]){
                  // Присваивание значения элементу:
                  vals[k]=value;
                  // Завершение метода:
                  return;
               }
            }
         }
         // Если массив нет или если элемент не найден:
         add(a,b,value); // Добавление нового элемента
      }
   }
}
// Класс с главным методом:
class UsingTwoDimIndexerDemo{
   // Главный метод:
   static void Main(){
      // Создание объекта:
      MyClass obj=new MyClass();
      // Проверка содержимого объекта:
      Console.WriteLine(obj);
      // Проверка значения элемента:
      Console.WriteLine("Значение элемента: "+obj['A',"Первый"]+"\n");
      // Проверка содержимого объекта:
      Console.WriteLine(obj);
      // Присваивание значения элементу:
      obj['B',"Второй"]=200;
      // Присваивание значения элементу:
      obj['C',"Третий"]=300;
      // Проверка содержимого объекта:
      Console.WriteLine(obj);
      // Проверка значения элемента:
      Console.WriteLine("Значение элемента: "+obj['B',"Первый"]+"\n");
      // Проверка значения элемента:
      Console.WriteLine("Значение элемента: "+obj['B',"Второй"]+"\n");
      // Проверка значения элемента:
      Console.WriteLine("Значение элемента: "+obj['A',"Третий"]+"\n");
      // Проверка содержимого объекта:
      Console.WriteLine(obj);
      // Присваивание значения элементу:
      obj['A',"Первый"]=100;
      // Проверка содержимого объекта:
      Console.WriteLine(obj);
      // Проверка значения элемента:
      Console.WriteLine("Значение элемента: "+obj['A',"Первый"]+"\n");
   }
}