﻿using System;
// Базовый класс с закрытым и защищенным полем:
class Alpha{
   // Закрытое целочисленное поле:
   private int num;
   // Защищенное символьное поле:
   protected char symb;
   // Открытый метод для считывания значения
   // целочисленного поля:
   public int getNum(){
      return num;
   }
   // Открытый метод для считывания значения
   // символьного поля:
   public char getSymb(){
      return symb;
   }
   // Открытый метод для присваивания значения
   // целочисленному полю:
   public void setNum(int n){
      num=n;
   }
   // Открытый метод для присваивания значения
   // символьному полю:
   public void setSymb(char s){
      symb=s;
   }
}
// Производный класс:
class Bravo:Alpha{
   // Открытое символьное свойство:
   public char symbol{
      // Аксессор для считывания значения свойства:
      get{
         // Обращение к защищенному унаследованному полю:
         return symb;
      }
      // Аксессор для присваивания значения свойству:
      set{
         // Обращение к защищенному унаследованному полю:
         symb=value;
      }
   }
   // Открытое целочисленное свойство:
   public int number{
      // Аксессор для считывания значения свойства:
      get{
         // Вызов открытого унаследованного метода,
         // возвращающего значение закрытого поля
         // из базового класса:
         return getNum();
      }
      // Аксессор для присваивания значения свойству:
      set{
         // Вызов открытого унаследованного метода для
         // присваивания значения закрытому полю
         // из базового класса:
         setNum(value);
      }
   }
}
// Класс с главным методом:
class PrivateAndProtectedDemo{
   // Главный метод:
   static void Main(){
      // Создание объекта базового класса:
      Alpha A=new Alpha();
      // Вызов метода для присваивания значения
      // целочисленному полю:
      A.setNum(100);
      // Вызов метода для присваивания значения
      // символьному полю:
      A.setSymb('A');
      // Вызов методов для считывания значений полей:
      Console.WriteLine("Объект A: {0} и {1}",A.getNum(),A.getSymb());
      // Создание объекта производного класса:
      Bravo B=new Bravo();
      // Вызов метода для присваивания значения
      // целочисленному полю:
      B.setNum(200);
      // Вызов метода для присваивания значения
      // символьному полю:
      B.setSymb('B');
      // Вызов методов для считывания значений полей:
      Console.WriteLine("Объект B: {0} и {1}",B.getNum(),B.getSymb());
      // Присваивание значения целочисленному свойству:
      B.number=300;
      // Присваивание значения символьному свойству:
      B.symbol='C';
      // Считывание значений свойств:
      Console.WriteLine("Объект B: {0} и {1}",B.number,B.symbol);
   }
}